<?xml version="1.0" encoding="UTF-8"?>
<jmeterTestPlan version="1.2" properties="5.0" jmeter="5.5">
  <hashTree>
    <TestPlan guiclass="TestPlanGui" testclass="TestPlan" testname="Test Plan" enabled="true">
      <stringProp name="TestPlan.comments"></stringProp>
      <boolProp name="TestPlan.functional_mode">false</boolProp>
      <boolProp name="TestPlan.tearDown_on_shutdown">true</boolProp>
      <boolProp name="TestPlan.serialize_threadgroups">false</boolProp>
      <elementProp name="TestPlan.user_defined_variables" elementType="Arguments" guiclass="ArgumentsPanel" testclass="Arguments" testname="User Defined Variables" enabled="true">
        <collectionProp name="Arguments.arguments"/>
      </elementProp>
      <stringProp name="TestPlan.user_define_classpath"></stringProp>
    </TestPlan>
    <hashTree>
      <ThreadGroup guiclass="ThreadGroupGui" testclass="ThreadGroup" testname="Manage Properties" enabled="true">
        <stringProp name="ThreadGroup.on_sample_error">continue</stringProp>
        <elementProp name="ThreadGroup.main_controller" elementType="LoopController" guiclass="LoopControlPanel" testclass="LoopController" testname="Loop Controller" enabled="true">
          <boolProp name="LoopController.continue_forever">false</boolProp>
          <stringProp name="LoopController.loops">1</stringProp>
        </elementProp>
        <stringProp name="ThreadGroup.num_threads">1</stringProp>
        <stringProp name="ThreadGroup.ramp_time">1</stringProp>
        <boolProp name="ThreadGroup.scheduler">false</boolProp>
        <stringProp name="ThreadGroup.duration"></stringProp>
        <stringProp name="ThreadGroup.delay"></stringProp>
        <boolProp name="ThreadGroup.same_user_on_next_iteration">true</boolProp>
      </ThreadGroup>
      <hashTree>
        <JSR223Sampler guiclass="TestBeanGUI" testclass="JSR223Sampler" testname="Remove All @Properties" enabled="false">
          <stringProp name="TestPlan.comments">
Remove all properties beginning with @
</stringProp>
          <stringProp name="cacheKey">true</stringProp>
          <stringProp name="filename"></stringProp>
          <stringProp name="parameters"></stringProp>
          <stringProp name="script">def sizeBefore = props.size();
props.removeAll { it.getKey().startsWith(&quot;@&quot;) }
log.info(&quot;****** {} properties deleted&quot;, sizeBefore - props.size() );</stringProp>
          <stringProp name="scriptLanguage">groovy</stringProp>
        </JSR223Sampler>
        <hashTree/>
        <JSR223Sampler guiclass="TestBeanGUI" testclass="JSR223Sampler" testname="Load Properties" enabled="true">
          <stringProp name="TestPlan.comments">
Load properties from file
Filename must be set in Parameters field

use ~/ for path relative to base path
</stringProp>
          <stringProp name="cacheKey">true</stringProp>
          <stringProp name="filename"></stringProp>
          <stringProp name="parameters">user.properties</stringProp>
          <stringProp name="script">import org.apache.jmeter.services.FileServer;

sizeBefore = props.size();
filename = Parameters  // filename in Parameters field.  Default folder is JMeter base folder.

FileServer fs = FileServer.getFileServer();

// resolve ~/ to current base dir
filename = fs.resolveBaseRelativeName(filename);
log.info(&quot;****** loading properties from {}&quot;, filename );

FileInputStream inputStream = new FileInputStream(new File(filename));
props.load(inputStream);
inputStream.close();
 
log.info(&quot;****** {} properties added&quot;, props.size() - sizeBefore );
</stringProp>
          <stringProp name="scriptLanguage">groovy</stringProp>
        </JSR223Sampler>
        <hashTree/>
      </hashTree>
      <SetupThreadGroup guiclass="SetupThreadGroupGui" testclass="SetupThreadGroup" testname="setUp Thread Group" enabled="true">
        <stringProp name="ThreadGroup.on_sample_error">continue</stringProp>
        <elementProp name="ThreadGroup.main_controller" elementType="LoopController" guiclass="LoopControlPanel" testclass="LoopController" testname="Loop Controller" enabled="true">
          <boolProp name="LoopController.continue_forever">false</boolProp>
          <stringProp name="LoopController.loops">1</stringProp>
        </elementProp>
        <stringProp name="ThreadGroup.num_threads">1</stringProp>
        <stringProp name="ThreadGroup.ramp_time">1</stringProp>
        <boolProp name="ThreadGroup.scheduler">false</boolProp>
        <stringProp name="ThreadGroup.duration"></stringProp>
        <stringProp name="ThreadGroup.delay"></stringProp>
        <boolProp name="ThreadGroup.same_user_on_next_iteration">true</boolProp>
      </SetupThreadGroup>
      <hashTree>
        <JSR223Sampler guiclass="TestBeanGUI" testclass="JSR223Sampler" testname="Log Properties" enabled="true">
          <stringProp name="scriptLanguage">groovy</stringProp>
          <stringProp name="parameters"></stringProp>
          <stringProp name="filename"></stringProp>
          <stringProp name="cacheKey">true</stringProp>
          <stringProp name="script">SampleResult.setIgnore()

// write properties starting with @ to JMeter log file
jmeterProperties = &quot;\n******************** JMeter @ Properties ********************\n&quot;
props.sort().each { property -&gt;
	if (property.getKey().startsWith(&quot;@&quot;)){
    		jmeterProperties += property 
    		jmeterProperties += &quot;\n&quot;
	}
}
jmeterProperties += &quot;************************************************************&quot;

if (log.isInfoEnabled()){
	log.info(&quot;{}&quot;, jmeterProperties)
} else if (log.isErrorEnabled() ){
	log.error(&quot;{}&quot;, jmeterProperties)
}
</stringProp>
        </JSR223Sampler>
        <hashTree/>
        <JSR223Sampler guiclass="TestBeanGUI" testclass="JSR223Sampler" testname="Prefix Group Name" enabled="true">
          <stringProp name="TestPlan.comments">Controls all post-processor Prefix Group Name</stringProp>
          <stringProp name="scriptLanguage">groovy</stringProp>
          <stringProp name="parameters"></stringProp>
          <stringProp name="filename"></stringProp>
          <stringProp name="cacheKey">true</stringProp>
          <stringProp name="script">SampleResult.setIgnore()

// check for string value in properties
if ( props.get(&quot;@prefixGroupName&quot;)?.toLowerCase()?.trim() == &quot;true&quot; ) {
	props.put(&quot;@prefixGroupName&quot;, &quot;true&quot;)
} else {
	props.put(&quot;@prefixGroupName&quot;, &quot;false&quot;)
}

if ( props.get(&quot;@prefixStepNumber&quot;)?.toLowerCase()?.trim() == &quot;true&quot; ) {
	props.put(&quot;@prefixStepNumber&quot;, &quot;true&quot;)
} else {
	props.put(&quot;@prefixStepNumber&quot;, &quot;false&quot;)
}

log.debug(&quot;***** Prefix Group Name: {}&quot;, props.get(&quot;@prefixGroupName&quot;))
</stringProp>
        </JSR223Sampler>
        <hashTree/>
      </hashTree>
    </hashTree>
  </hashTree>
</jmeterTestPlan>
